package com.liang.service;

import com.liang.entity.PrjMember;
import com.liang.entity.StaBudgetapproval;
import com.liang.entity.StaTravelexpenses;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 差旅费(StaTravelexpenses)表服务接口
 *
 * @author makejava
 * @since 2023-04-26 09:50:01
 */
public interface StaTravelexpensesService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaTravelexpenses queryById(Integer id);

    /**
     * 分页查询
     *
     * @param staTravelexpenses 筛选条件
     * @param pageRequest       分页对象
     * @return 查询结果
     */
    Page<StaTravelexpenses> queryByPage(StaTravelexpenses staTravelexpenses, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param staTravelexpenses 实例对象
     * @return 实例对象
     */
    int insert(StaTravelexpenses staTravelexpenses);

    /**
     * 修改数据
     *
     * @param staTravelexpenses 实例对象
     * @return 实例对象
     */
    int update(StaTravelexpenses staTravelexpenses);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除差旅费
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

    /**
     * 批量插入差旅费
     *
     * @param expenseList
     * @return
     */
    int insertBatch(List<StaTravelexpenses> expenseList);

    /**
     * 获取差旅费列表
     *
     * @return
     */
    List<StaTravelexpenses> getClfList(Integer zb);

    List<StaTravelexpenses> queryByKyfh(String kyfh);

    /**
     * 项目报表（差旅费）查询
     *
     * @param xmmc 项目名称
     * @param ccdd 出差地点
     * @param qsrq 创建起始日期
     * @param jzrq 创建结束日期
     * @return
     */
    List<HashMap<String, Object>> searchTravelexpensesCost(Map map);

}
